<?php
/**
 * class name: dbConnect
 * Autor: Lucas Silva Vasconcelos (Sh4d0wn) <vasconcelos@mma.com.br>
 * Data: 08-03-2004 \ Ultima alteraao:
 * versao: 1.0
 * -----------------------------------------------------------------------------
 * Classe que tenta tornar simples a manutencao de scripts
 * que usam banco de dados. Pois basta trocar o nome das funcoes
 * pre-definidas do PHP - DATASOURCE que seu script ir funcionar
 * -----------------------------------------------------------------------------
 * Sugestao: utilize um replace para migrar o db. Ex:
 * replace -> mysql_ por mssql_
 * assim vc podera usar os script que usam esta classe com o MS SQL Server.
 */

class dbConnect {
    var $db; // name of the db
    var $conn; // handler of connection
    
    /**
     * Constructor default da classe
     * @param string $tp_db - banco a ser selecionado
     * @param string $tp_host - url do host
     * @param string $tp_user - usuario
     * @param string $tp_pass - senha do db
     * @return connection id - handler de connexao
     */
    function dbConnect($tp_db, $tp_host = "localhost", $tp_user = "root", $tp_pass = "") {
        $this->db = $tp_db;
        
        $this->conn = @mysql_connect($tp_host, $tp_user, $tp_pass);
        
        if (mysql_error()) {
            echo "ERROR! >> Falha ao tentar conectar ao banco de dados.<br />".mysql_error();
        } else {
            @mysql_select_db($this->db);
            
            if (mysql_error()) {
                echo "ERROR! >> Falha ao tentar selecionar o banco de dados.<br />".mysql_error();
            }
        }
        
        return $this->conn;
    }
    
    /**
     * Altera o banco selecionado
     * @param string $tp_db - nome do banco que quer se connectar
     */
    function fn_setDb($tp_db) {
        $this->db = $tp_db;
        @mysql_select_db($this->db);
        
        if (mysql_error()) {
            echo "ERROR! >> Falha ao tentar selecionar o banco de dados.<br />".mysql_error();
        }
    }
    
    /**
     * Pega o nome do db atual
     * @return string - nome do db atualmente selecionado
     */
    function fn_getDb() {
        return $this->db;
    }
    
    /**
     * Funcao que retorna o link mysql atual
     * @return resource (mysql link) - id de connexao
     */
    function fn_getConn() {
        return $this->conn;
    }
    
    /**
     * Funcao que executa as queryes
     * @param string $tp_query - query sql
     * @return retorna handler se for um select
     */
    function fn_dbQuery($tp_query) {
        $sql_result = @mysql_query($tp_query,$this->conn);
        
        if (mysql_error()) {
            echo "ERROR! >> Falha ao tentar selecionar os dados.<br />".mysql_error();
        } else {
            return $sql_result;
        }
    }
    
    /**
     * Retorna o numero de linhas resultante
     * de uma consulta
     * @return int - numero de resultados da consulta
     */
    function fn_getRows($tp_sql) {
        $tp = @mysql_num_rows($tp_sql);
        
        if (mysql_error()) {
            echo "ERROR! >> Falha ao tentar contar o nmero de linhas da busca.<br />".mysql_error();
        }
        
        return $tp;
    }
    
    /**
     * Funcao q retorna um vetor associativo
     * @return array - vetor associativo com resultado
     * de uma query
     * formato do array [0][x][..]
     */
    function fn_getArray($tp_sql) {
        $x        = 0;
        $tp_array = array();
        
        while ($tp = @mysql_fetch_assoc($tp_sql)) {
            $tp_array += array($x=>$tp);
            $x++;
        }
        
        if (mysql_error()) {
            echo "ERROR! >> Falha ao tentar criar array associativo.".mysql_error();
        } else {
            return $tp_array;
        }
    }
    
    /**
     * Funcao que retorna um resultado
     * @param string $tp_field - nome do campo que deve retornar o valor
     * @param int $tp_line - numero da linha que o est o resultado
     * @param handler sql $tp_sql - id de uma consulta sql
     * @return mixed var - conteudo da coluna
     */
    function fn_getResult($tp_sql, $tp_field, $tp_line = 0) {
        $tp = @mysql_result($tp_sql, $tp_line, $tp_field);
        //echo $tp;
        if (mysql_error()) {
            echo "ERROR! >> Falha ao selecionar resultado da consulta.".mysql_error();
        } else {
            return $tp;
        }
    }
    
    /**
     * Funcao para fechar a conexao com o db
     */
    function fn_dbClose() {
        @mysql_close($this->conn);
    }
}
?>
